using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;
using System.Runtime.InteropServices;
using System.IO;

namespace sl
{ //ZEDMat is a wrapper for sl.Mat{

    public class CaptureImage : MonoBehaviour
    {
        public GameObject ZED_Rig_Stereo;
        private ZEDManager zedmanager;
        sl.ERROR_CODE err = sl.ERROR_CODE.CAMERA_NOT_DETECTED;
        sl.ZEDMat zedmat;


        public void Awake()
        {
            zedmat = new sl.ZEDMat();
            zedmat.Create(new sl.Resolution(1280, 720), ZEDMat.MAT_TYPE.MAT_8U_C4, ZEDMat.MEM.MEM_CPU);
            if (!zedmanager)
            {
                zedmanager = FindObjectOfType<ZEDManager>();
            }
        }

        // Start is called before the first frame update
        void Start()
        {
        }

        // Update is called once per frame
        void Update()
        {
            if (Input.GetKeyDown(KeyCode.V))
            {
                Debug.Log("Update");

                err = zedmanager.zedCamera.RetrieveImage(zedmat, VIEW.LEFT_UNRECTIFIED, ZEDMat.MEM.MEM_CPU);
                SaveImagePng(zedmat);
            }
        }

        void SaveImagePng(sl.ZEDMat zedmat)
        {
            int matwidth = zedmat.GetWidth();
            int matheight = zedmat.GetHeight();
            IntPtr matptr = zedmat.GetPtr(ZEDMat.MEM.MEM_CPU);
            byte[] matbytes = new byte[matwidth * matheight * 4];
            Marshal.Copy(matptr, matbytes, 0, matbytes.Length);

            //Flip the image vertically
            //Note that this could be done straight from the pointer (without matbytes) but doing it this way for clarity. 
            byte[] flippedbytes = new byte[matwidth * matheight * 4];
            int steplength = matwidth * 4; //Also retrievable from ZEDMat.GetStepBytes();
            for (int i = 0; i < matbytes.Length; i += steplength)
            {
                //Array.Copy(matbytes, i, flippedbytes, flippedbytes.Length - i - steplength, steplength);
            }

            //Create the copy texture and encode it
            Texture2D bgrCopy = new Texture2D(matwidth, matheight, TextureFormat.BGRA32, false); //BRGA32 to account for the ZED's different color space
            bgrCopy.LoadRawTextureData(matbytes);
            bgrCopy.Apply();

            byte[] pngbytes = bgrCopy.EncodeToPNG();
            File.WriteAllBytes(Application.dataPath + "/../ZEDRGB.png", pngbytes);
            Debug.Log("Save image");
        }
    }
}